/* Color.c generated by valac 0.32.1, the Vala compiler
 * generated from Color.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_color_from_hsv (gdouble h, gdouble s, gdouble v, PlankColor* result);
void plank_color_set_hsv (PlankColor *self, gdouble h, gdouble s, gdouble v);
void plank_color_from_hsl (gdouble h, gdouble s, gdouble l, PlankColor* result);
void plank_color_set_hsl (PlankColor *self, gdouble h, gdouble s, gdouble v);
static void plank_color_hsv_to_rgb (gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b);
void plank_color_set_hue (PlankColor *self, gdouble hue);
static void plank_color_rgb_to_hsv (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v);
void plank_color_set_sat (PlankColor *self, gdouble sat);
void plank_color_set_val (PlankColor *self, gdouble val);
void plank_color_get_hsv (PlankColor *self, gdouble* h, gdouble* s, gdouble* v);
gdouble plank_color_get_hue (PlankColor *self);
gdouble plank_color_get_sat (PlankColor *self);
gdouble plank_color_get_val (PlankColor *self);
void plank_color_add_hue (PlankColor *self, gdouble val);
void plank_color_set_min_sat (PlankColor *self, gdouble sat);
void plank_color_set_min_val (PlankColor *self, gdouble val);
void plank_color_set_max_sat (PlankColor *self, gdouble sat);
void plank_color_set_max_val (PlankColor *self, gdouble val);
void plank_color_multiply_sat (PlankColor *self, gdouble amount);
void plank_color_brighten_val (PlankColor *self, gdouble amount);
void plank_color_darken_val (PlankColor *self, gdouble amount);
void plank_color_darken_by_sat (PlankColor *self, gdouble amount);
void plank_color_get_hsl (PlankColor *self, gdouble* h, gdouble* s, gdouble* l);
static void plank_color_rgb_to_hsl (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* l);
static void plank_color_hsl_to_rgb (gdouble h, gdouble s, gdouble l, gdouble* r, gdouble* g, gdouble* b);
gchar* plank_color_to_prefs_string (PlankColor *self);
void plank_color_from_prefs_string (const gchar* s, PlankColor* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Create new color for the given HSV values while
 * h in [0,360), s in [0,1] and v in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param v the value for the color
 * @return new {@link Color} based on the HSV values
 */
void plank_color_from_hsv (gdouble h, gdouble s, gdouble v, PlankColor* result) {
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	_tmp0_.red = 1.0;
	_tmp0_.green = 1.0;
	_tmp0_.blue = 1.0;
	_tmp0_.alpha = 1.0;
	_result_ = _tmp0_;
	_tmp1_ = h;
	_tmp2_ = s;
	_tmp3_ = v;
	plank_color_set_hsv (&_result_, _tmp1_, _tmp2_, _tmp3_);
	*result = _result_;
	return;
}


/**
 * Create new color for the given HSL values while
 * h in [0,360), s in [0,1] and l in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param l the lightness for the color
 * @return new {@link Color} based on the HSL values
 */
void plank_color_from_hsl (gdouble h, gdouble s, gdouble l, PlankColor* result) {
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	_tmp0_.red = 1.0;
	_tmp0_.green = 1.0;
	_tmp0_.blue = 1.0;
	_tmp0_.alpha = 1.0;
	_result_ = _tmp0_;
	_tmp1_ = h;
	_tmp2_ = s;
	_tmp3_ = l;
	plank_color_set_hsl (&_result_, _tmp1_, _tmp2_, _tmp3_);
	*result = _result_;
	return;
}


/**
 * Set HSV color values of this color.
 */
void plank_color_set_hsv (PlankColor *self, gdouble h, gdouble s, gdouble v) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = h;
	_tmp1_ = s;
	_tmp2_ = v;
	plank_color_hsv_to_rgb (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	(*self).red = _tmp3_;
	(*self).green = _tmp4_;
	(*self).blue = _tmp5_;
}


/**
 * Sets the hue for the color.
 *
 * @param hue the new hue for the color
 */
void plank_color_set_hue (PlankColor *self, gdouble hue) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	_tmp0_ = hue;
	_tmp1_ = hue;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 360)), "hue >= 0 && hue <= 360");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = hue;
	h = _tmp8_;
	_tmp9_ = h;
	plank_color_hsv_to_rgb (_tmp9_, s, v, &_tmp10_, &_tmp11_, &_tmp12_);
	(*self).red = _tmp10_;
	(*self).green = _tmp11_;
	(*self).blue = _tmp12_;
}


/**
 * Sets the saturation for the color.
 *
 * @param sat the new saturation for the color
 */
void plank_color_set_sat (PlankColor *self, gdouble sat) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	_tmp0_ = sat;
	_tmp1_ = sat;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = sat;
	s = _tmp8_;
	_tmp9_ = s;
	plank_color_hsv_to_rgb (h, _tmp9_, v, &_tmp10_, &_tmp11_, &_tmp12_);
	(*self).red = _tmp10_;
	(*self).green = _tmp11_;
	(*self).blue = _tmp12_;
}


/**
 * Sets the value for the color.
 *
 * @param val the new value for the color
 */
void plank_color_set_val (PlankColor *self, gdouble val) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	_tmp0_ = val;
	_tmp1_ = val;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = val;
	v = _tmp8_;
	_tmp9_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
	(*self).red = _tmp10_;
	(*self).green = _tmp11_;
	(*self).blue = _tmp12_;
}


/**
 * Get HSV color values of this color.
 */
void plank_color_get_hsv (PlankColor *self, gdouble* h, gdouble* s, gdouble* v) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	_vala_h = _tmp3_;
	_vala_s = _tmp4_;
	_vala_v = _tmp5_;
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (v) {
		*v = _vala_v;
	}
}


/**
 * Returns the hue for the color.
 *
 * @return the hue for the color
 */
gdouble plank_color_get_hue (PlankColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = h;
	return result;
}


/**
 * Returns the saturation for the color.
 *
 * @return the saturation for the color
 */
gdouble plank_color_get_sat (PlankColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = s;
	return result;
}


/**
 * Returns the value for the color.
 *
 * @return the value for the color
 */
gdouble plank_color_get_val (PlankColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = v;
	return result;
}


/**
 * Increases the color's hue.
 *
 * @param val the amount to add to the hue
 */
void plank_color_add_hue (PlankColor *self, gdouble val) {
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = h;
	_tmp7_ = val;
	h = fmod (fmod (_tmp6_ + _tmp7_, 360) + 360, 360);
	_tmp8_ = h;
	plank_color_hsv_to_rgb (_tmp8_, s, v, &_tmp9_, &_tmp10_, &_tmp11_);
	(*self).red = _tmp9_;
	(*self).green = _tmp10_;
	(*self).blue = _tmp11_;
}


/**
 * Assures the color's saturation is greater than or equal to the given one.
 *
 * @param sat the minimum saturation
 */
void plank_color_set_min_sat (PlankColor *self, gdouble sat) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	_tmp0_ = sat;
	_tmp1_ = sat;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = s;
	_tmp9_ = sat;
	_tmp10_ = MAX (_tmp8_, _tmp9_);
	s = _tmp10_;
	_tmp11_ = s;
	plank_color_hsv_to_rgb (h, _tmp11_, v, &_tmp12_, &_tmp13_, &_tmp14_);
	(*self).red = _tmp12_;
	(*self).green = _tmp13_;
	(*self).blue = _tmp14_;
}


/**
 * Assures the color's value is greater than or equal to the given one.
 *
 * @param val the minimum value
 */
void plank_color_set_min_val (PlankColor *self, gdouble val) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	_tmp0_ = val;
	_tmp1_ = val;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = v;
	_tmp9_ = val;
	_tmp10_ = MAX (_tmp8_, _tmp9_);
	v = _tmp10_;
	_tmp11_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	(*self).red = _tmp12_;
	(*self).green = _tmp13_;
	(*self).blue = _tmp14_;
}


/**
 * Assures the color's saturation is less than or equal to the given one.
 *
 * @param sat the maximum saturation
 */
void plank_color_set_max_sat (PlankColor *self, gdouble sat) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	_tmp0_ = sat;
	_tmp1_ = sat;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = s;
	_tmp9_ = sat;
	_tmp10_ = MIN (_tmp8_, _tmp9_);
	s = _tmp10_;
	_tmp11_ = s;
	plank_color_hsv_to_rgb (h, _tmp11_, v, &_tmp12_, &_tmp13_, &_tmp14_);
	(*self).red = _tmp12_;
	(*self).green = _tmp13_;
	(*self).blue = _tmp14_;
}


/**
 * Assures the color's value is less than or equal to the given one.
 *
 * @param val the maximum value
 */
void plank_color_set_max_val (PlankColor *self, gdouble val) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	_tmp0_ = val;
	_tmp1_ = val;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = v;
	_tmp9_ = val;
	_tmp10_ = MIN (_tmp8_, _tmp9_);
	v = _tmp10_;
	_tmp11_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	(*self).red = _tmp12_;
	(*self).green = _tmp13_;
	(*self).blue = _tmp14_;
}


/**
 * Multiplies the color's saturation using the amount.
 *
 * @param amount amount to multiply the saturation by
 */
void plank_color_multiply_sat (PlankColor *self, gdouble amount) {
	gdouble _tmp0_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	_tmp0_ = amount;
	_vala_return_if_fail (_tmp0_ >= ((gdouble) 0), "amount >= 0");
	_tmp1_ = (*self).red;
	_tmp2_ = (*self).green;
	_tmp3_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp1_, _tmp2_, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	h = _tmp4_;
	s = _tmp5_;
	v = _tmp6_;
	_tmp7_ = s;
	_tmp8_ = amount;
	_tmp9_ = MIN ((gdouble) 1, _tmp7_ * _tmp8_);
	s = _tmp9_;
	_tmp10_ = s;
	plank_color_hsv_to_rgb (h, _tmp10_, v, &_tmp11_, &_tmp12_, &_tmp13_);
	(*self).red = _tmp11_;
	(*self).green = _tmp12_;
	(*self).blue = _tmp13_;
}


/**
 * Brighten the color's value using the value.
 *
 * @param amount percent of the value to brighten by
 */
void plank_color_brighten_val (PlankColor *self, gdouble amount) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	_tmp0_ = amount;
	_tmp1_ = amount;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = v;
	_tmp9_ = v;
	_tmp10_ = amount;
	_tmp11_ = MIN ((gdouble) 1, _tmp8_ + ((1 - _tmp9_) * _tmp10_));
	v = _tmp11_;
	_tmp12_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
	(*self).red = _tmp13_;
	(*self).green = _tmp14_;
	(*self).blue = _tmp15_;
}


/**
 * Darkens the color's value using the value.
 *
 * @param amount percent of the value to darken by
 */
void plank_color_darken_val (PlankColor *self, gdouble amount) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	_tmp0_ = amount;
	_tmp1_ = amount;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = v;
	_tmp9_ = v;
	_tmp10_ = amount;
	_tmp11_ = MAX ((gdouble) 0, _tmp8_ - ((1 - _tmp9_) * _tmp10_));
	v = _tmp11_;
	_tmp12_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
	(*self).red = _tmp13_;
	(*self).green = _tmp14_;
	(*self).blue = _tmp15_;
}


/**
 * Darkens the color's value using the saturtion.
 *
 * @param amount percent of the saturation to darken by
 */
void plank_color_darken_by_sat (PlankColor *self, gdouble amount) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	_tmp0_ = amount;
	_tmp1_ = amount;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp2_ = (*self).red;
	_tmp3_ = (*self).green;
	_tmp4_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	h = _tmp5_;
	s = _tmp6_;
	v = _tmp7_;
	_tmp8_ = v;
	_tmp9_ = amount;
	_tmp10_ = MAX ((gdouble) 0, _tmp8_ - (_tmp9_ * s));
	v = _tmp10_;
	_tmp11_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	(*self).red = _tmp12_;
	(*self).green = _tmp13_;
	(*self).blue = _tmp14_;
}


/**
 * Get HSL color values of this color.
 */
void plank_color_get_hsl (PlankColor *self, gdouble* h, gdouble* s, gdouble* l) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsl (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	_vala_h = _tmp3_;
	_vala_s = _tmp4_;
	_vala_l = _tmp5_;
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (l) {
		*l = _vala_l;
	}
}


/**
 * Set HSL color values of this color.
 */
void plank_color_set_hsl (PlankColor *self, gdouble h, gdouble s, gdouble v) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = h;
	_tmp1_ = s;
	_tmp2_ = v;
	plank_color_hsl_to_rgb (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	(*self).red = _tmp3_;
	(*self).green = _tmp4_;
	(*self).blue = _tmp5_;
}


static void plank_color_rgb_to_hsv (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble min = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble max = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	gdouble _tmp42_ = 0.0;
	_tmp0_ = r;
	_tmp1_ = r;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "r >= 0 && r <= 1");
	_tmp2_ = g;
	_tmp3_ = g;
	_vala_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)), "g >= 0 && g <= 1");
	_tmp4_ = b;
	_tmp5_ = b;
	_vala_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)), "b >= 0 && b <= 1");
	_tmp6_ = r;
	_tmp7_ = g;
	_tmp8_ = b;
	_tmp9_ = MAX (_tmp7_, _tmp8_);
	_tmp10_ = MAX (_tmp6_, _tmp9_);
	_vala_v = _tmp10_;
	_tmp11_ = _vala_v;
	if (_tmp11_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		_vala_s = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp12_ = r;
	_tmp13_ = _vala_v;
	r = _tmp12_ / _tmp13_;
	_tmp14_ = g;
	_tmp15_ = _vala_v;
	g = _tmp14_ / _tmp15_;
	_tmp16_ = b;
	_tmp17_ = _vala_v;
	b = _tmp16_ / _tmp17_;
	_tmp18_ = r;
	_tmp19_ = g;
	_tmp20_ = b;
	_tmp21_ = MIN (_tmp19_, _tmp20_);
	_tmp22_ = MIN (_tmp18_, _tmp21_);
	min = _tmp22_;
	_tmp23_ = r;
	_tmp24_ = g;
	_tmp25_ = b;
	_tmp26_ = MAX (_tmp24_, _tmp25_);
	_tmp27_ = MAX (_tmp23_, _tmp26_);
	max = _tmp27_;
	_tmp28_ = max;
	_tmp29_ = min;
	delta = _tmp28_ - _tmp29_;
	_tmp30_ = delta;
	_vala_s = _tmp30_;
	_tmp31_ = _vala_s;
	if (_tmp31_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp32_ = r;
	_tmp33_ = min;
	_tmp34_ = delta;
	r = (_tmp32_ - _tmp33_) / _tmp34_;
	_tmp35_ = g;
	_tmp36_ = min;
	_tmp37_ = delta;
	g = (_tmp35_ - _tmp36_) / _tmp37_;
	_tmp38_ = b;
	_tmp39_ = min;
	_tmp40_ = delta;
	b = (_tmp38_ - _tmp39_) / _tmp40_;
	_tmp41_ = max;
	_tmp42_ = r;
	if (_tmp41_ == _tmp42_) {
		gdouble _tmp43_ = 0.0;
		gdouble _tmp44_ = 0.0;
		gdouble _tmp45_ = 0.0;
		_tmp43_ = g;
		_tmp44_ = b;
		_vala_h = 0 + (60 * (_tmp43_ - _tmp44_));
		_tmp45_ = _vala_h;
		if (_tmp45_ < ((gdouble) 0)) {
			gdouble _tmp46_ = 0.0;
			_tmp46_ = _vala_h;
			_vala_h = _tmp46_ + 360;
		}
	} else {
		gdouble _tmp47_ = 0.0;
		gdouble _tmp48_ = 0.0;
		_tmp47_ = max;
		_tmp48_ = g;
		if (_tmp47_ == _tmp48_) {
			gdouble _tmp49_ = 0.0;
			gdouble _tmp50_ = 0.0;
			_tmp49_ = b;
			_tmp50_ = r;
			_vala_h = 120 + (60 * (_tmp49_ - _tmp50_));
		} else {
			gdouble _tmp51_ = 0.0;
			gdouble _tmp52_ = 0.0;
			_tmp51_ = r;
			_tmp52_ = g;
			_vala_h = 240 + (60 * (_tmp51_ - _tmp52_));
		}
	}
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (v) {
		*v = _vala_v;
	}
}


static void plank_color_hsv_to_rgb (gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b) {
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	_tmp0_ = h;
	_tmp1_ = h;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ < ((gdouble) 360)), "h >= 0 && h < 360");
	_tmp2_ = s;
	_tmp3_ = s;
	_vala_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)), "s >= 0 && s <= 1");
	_tmp4_ = v;
	_tmp5_ = v;
	_vala_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)), "v >= 0 && v <= 1");
	_tmp6_ = s;
	if (_tmp6_ == ((gdouble) 0)) {
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		_tmp7_ = v;
		_vala_r = _tmp7_;
		_tmp8_ = v;
		_vala_g = _tmp8_;
		_tmp9_ = v;
		_vala_b = _tmp9_;
	} else {
		gint secNum = 0;
		gdouble _tmp10_ = 0.0;
		gdouble fracSec = 0.0;
		gdouble _tmp11_ = 0.0;
		gint _tmp12_ = 0;
		gdouble p = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble q = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		gdouble t = 0.0;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gint _tmp21_ = 0;
		_tmp10_ = h;
		secNum = (gint) (_tmp10_ / 60);
		_tmp11_ = h;
		_tmp12_ = secNum;
		fracSec = (_tmp11_ / 60.0) - _tmp12_;
		_tmp13_ = v;
		_tmp14_ = s;
		p = _tmp13_ * (1 - _tmp14_);
		_tmp15_ = v;
		_tmp16_ = s;
		_tmp17_ = fracSec;
		q = _tmp15_ * (1 - (_tmp16_ * _tmp17_));
		_tmp18_ = v;
		_tmp19_ = s;
		_tmp20_ = fracSec;
		t = _tmp18_ * (1 - (_tmp19_ * (1 - _tmp20_)));
		_tmp21_ = secNum;
		switch (_tmp21_) {
			case 0:
			{
				gdouble _tmp22_ = 0.0;
				gdouble _tmp23_ = 0.0;
				gdouble _tmp24_ = 0.0;
				_tmp22_ = v;
				_vala_r = _tmp22_;
				_tmp23_ = t;
				_vala_g = _tmp23_;
				_tmp24_ = p;
				_vala_b = _tmp24_;
				break;
			}
			case 1:
			{
				gdouble _tmp25_ = 0.0;
				gdouble _tmp26_ = 0.0;
				gdouble _tmp27_ = 0.0;
				_tmp25_ = q;
				_vala_r = _tmp25_;
				_tmp26_ = v;
				_vala_g = _tmp26_;
				_tmp27_ = p;
				_vala_b = _tmp27_;
				break;
			}
			case 2:
			{
				gdouble _tmp28_ = 0.0;
				gdouble _tmp29_ = 0.0;
				gdouble _tmp30_ = 0.0;
				_tmp28_ = p;
				_vala_r = _tmp28_;
				_tmp29_ = v;
				_vala_g = _tmp29_;
				_tmp30_ = t;
				_vala_b = _tmp30_;
				break;
			}
			case 3:
			{
				gdouble _tmp31_ = 0.0;
				gdouble _tmp32_ = 0.0;
				gdouble _tmp33_ = 0.0;
				_tmp31_ = p;
				_vala_r = _tmp31_;
				_tmp32_ = q;
				_vala_g = _tmp32_;
				_tmp33_ = v;
				_vala_b = _tmp33_;
				break;
			}
			case 4:
			{
				gdouble _tmp34_ = 0.0;
				gdouble _tmp35_ = 0.0;
				gdouble _tmp36_ = 0.0;
				_tmp34_ = t;
				_vala_r = _tmp34_;
				_tmp35_ = p;
				_vala_g = _tmp35_;
				_tmp36_ = v;
				_vala_b = _tmp36_;
				break;
			}
			case 5:
			{
				gdouble _tmp37_ = 0.0;
				gdouble _tmp38_ = 0.0;
				gdouble _tmp39_ = 0.0;
				_tmp37_ = v;
				_vala_r = _tmp37_;
				_tmp38_ = p;
				_vala_g = _tmp38_;
				_tmp39_ = q;
				_vala_b = _tmp39_;
				break;
			}
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
	if (r) {
		*r = _vala_r;
	}
	if (g) {
		*g = _vala_g;
	}
	if (b) {
		*b = _vala_b;
	}
}


static void plank_color_rgb_to_hsl (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* l) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble max = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble min = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble r2 = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble g2 = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_ = 0.0;
	gdouble b2 = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	_tmp0_ = r;
	_tmp1_ = r;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)), "r >= 0 && r <= 1");
	_tmp2_ = g;
	_tmp3_ = g;
	_vala_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)), "g >= 0 && g <= 1");
	_tmp4_ = b;
	_tmp5_ = b;
	_vala_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)), "b >= 0 && b <= 1");
	_tmp6_ = r;
	_tmp7_ = g;
	_tmp8_ = b;
	_tmp9_ = MAX (_tmp7_, _tmp8_);
	_tmp10_ = MAX (_tmp6_, _tmp9_);
	max = _tmp10_;
	_tmp11_ = max;
	if (_tmp11_ == 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		_vala_l = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	_tmp12_ = r;
	_tmp13_ = g;
	_tmp14_ = b;
	_tmp15_ = MIN (_tmp13_, _tmp14_);
	_tmp16_ = MIN (_tmp12_, _tmp15_);
	min = _tmp16_;
	_tmp17_ = min;
	_tmp18_ = max;
	_vala_l = (_tmp17_ + _tmp18_) / 2.0;
	_tmp19_ = _vala_l;
	if (_tmp19_ <= 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	_tmp20_ = max;
	_tmp21_ = min;
	delta = _tmp20_ - _tmp21_;
	_tmp22_ = delta;
	if (_tmp22_ <= 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	_tmp24_ = _vala_l;
	if (_tmp24_ <= 0.5) {
		gdouble _tmp25_ = 0.0;
		gdouble _tmp26_ = 0.0;
		_tmp25_ = min;
		_tmp26_ = max;
		_tmp23_ = _tmp25_ + _tmp26_;
	} else {
		gdouble _tmp27_ = 0.0;
		gdouble _tmp28_ = 0.0;
		_tmp27_ = min;
		_tmp28_ = max;
		_tmp23_ = (2.0 - _tmp27_) - _tmp28_;
	}
	_tmp29_ = delta;
	_vala_s = _tmp29_ / _tmp23_;
	_tmp30_ = max;
	_tmp31_ = r;
	_tmp32_ = delta;
	r2 = (60 * (_tmp30_ - _tmp31_)) / _tmp32_;
	_tmp33_ = max;
	_tmp34_ = g;
	_tmp35_ = delta;
	g2 = (60 * (_tmp33_ - _tmp34_)) / _tmp35_;
	_tmp36_ = max;
	_tmp37_ = b;
	_tmp38_ = delta;
	b2 = (60 * (_tmp36_ - _tmp37_)) / _tmp38_;
	_tmp39_ = max;
	_tmp40_ = r;
	if (_tmp39_ == _tmp40_) {
		gdouble _tmp41_ = 0.0;
		gdouble _tmp42_ = 0.0;
		gdouble _tmp43_ = 0.0;
		_tmp41_ = b2;
		_tmp42_ = g2;
		_vala_h = _tmp41_ - _tmp42_;
		_tmp43_ = _vala_h;
		if (_tmp43_ < ((gdouble) 0)) {
			gdouble _tmp44_ = 0.0;
			_tmp44_ = _vala_h;
			_vala_h = _tmp44_ + 360;
		}
	} else {
		gdouble _tmp45_ = 0.0;
		gdouble _tmp46_ = 0.0;
		_tmp45_ = max;
		_tmp46_ = g;
		if (_tmp45_ == _tmp46_) {
			gdouble _tmp47_ = 0.0;
			gdouble _tmp48_ = 0.0;
			_tmp47_ = r2;
			_tmp48_ = b2;
			_vala_h = 120 + (_tmp47_ - _tmp48_);
		} else {
			gdouble _tmp49_ = 0.0;
			gdouble _tmp50_ = 0.0;
			_tmp49_ = g2;
			_tmp50_ = r2;
			_vala_h = 240 + (_tmp49_ - _tmp50_);
		}
	}
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (l) {
		*l = _vala_l;
	}
}


static void plank_color_hsl_to_rgb (gdouble h, gdouble s, gdouble l, gdouble* r, gdouble* g, gdouble* b) {
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble v = 0.0;
	gdouble _tmp14_ = 0.0;
	gint secNum = 0;
	gdouble _tmp18_ = 0.0;
	gdouble fracSec = 0.0;
	gdouble _tmp19_ = 0.0;
	gint _tmp20_ = 0;
	gdouble p = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble q = 0.0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble t = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gint _tmp32_ = 0;
	_tmp0_ = h;
	_tmp1_ = h;
	_vala_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ < ((gdouble) 360)), "h >= 0 && h < 360");
	_tmp2_ = s;
	_tmp3_ = s;
	_vala_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)), "s >= 0 && s <= 1");
	_tmp4_ = l;
	_tmp5_ = l;
	_vala_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)), "l >= 0 && l <= 1");
	_tmp7_ = l;
	if (_tmp7_ <= 0.5) {
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		_tmp8_ = l;
		_tmp9_ = s;
		_tmp6_ = _tmp8_ * (1.0 + _tmp9_);
	} else {
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		_tmp10_ = l;
		_tmp11_ = s;
		_tmp12_ = l;
		_tmp13_ = s;
		_tmp6_ = (_tmp10_ + _tmp11_) - (_tmp12_ * _tmp13_);
	}
	v = _tmp6_;
	_tmp14_ = v;
	if (_tmp14_ <= 0.0) {
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		_tmp15_ = l;
		_vala_r = _tmp15_;
		_tmp16_ = l;
		_vala_g = _tmp16_;
		_tmp17_ = l;
		_vala_b = _tmp17_;
		if (r) {
			*r = _vala_r;
		}
		if (g) {
			*g = _vala_g;
		}
		if (b) {
			*b = _vala_b;
		}
		return;
	}
	_tmp18_ = h;
	secNum = (gint) (_tmp18_ / 60);
	_tmp19_ = h;
	_tmp20_ = secNum;
	fracSec = (_tmp19_ / 30.0) - (2 * _tmp20_);
	_tmp21_ = l;
	_tmp22_ = v;
	_tmp23_ = l;
	p = _tmp21_ - (_tmp22_ - _tmp23_);
	_tmp24_ = v;
	_tmp25_ = v;
	_tmp26_ = l;
	_tmp27_ = fracSec;
	q = _tmp24_ - ((_tmp25_ - _tmp26_) * _tmp27_);
	_tmp28_ = l;
	_tmp29_ = v;
	_tmp30_ = l;
	_tmp31_ = fracSec;
	t = _tmp28_ + ((_tmp29_ - _tmp30_) * (_tmp31_ - 1));
	_tmp32_ = secNum;
	switch (_tmp32_) {
		case 0:
		{
			gdouble _tmp33_ = 0.0;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			_tmp33_ = v;
			_vala_r = _tmp33_;
			_tmp34_ = t;
			_vala_g = _tmp34_;
			_tmp35_ = p;
			_vala_b = _tmp35_;
			break;
		}
		case 1:
		{
			gdouble _tmp36_ = 0.0;
			gdouble _tmp37_ = 0.0;
			gdouble _tmp38_ = 0.0;
			_tmp36_ = q;
			_vala_r = _tmp36_;
			_tmp37_ = v;
			_vala_g = _tmp37_;
			_tmp38_ = p;
			_vala_b = _tmp38_;
			break;
		}
		case 2:
		{
			gdouble _tmp39_ = 0.0;
			gdouble _tmp40_ = 0.0;
			gdouble _tmp41_ = 0.0;
			_tmp39_ = p;
			_vala_r = _tmp39_;
			_tmp40_ = v;
			_vala_g = _tmp40_;
			_tmp41_ = t;
			_vala_b = _tmp41_;
			break;
		}
		case 3:
		{
			gdouble _tmp42_ = 0.0;
			gdouble _tmp43_ = 0.0;
			gdouble _tmp44_ = 0.0;
			_tmp42_ = p;
			_vala_r = _tmp42_;
			_tmp43_ = q;
			_vala_g = _tmp43_;
			_tmp44_ = v;
			_vala_b = _tmp44_;
			break;
		}
		case 4:
		{
			gdouble _tmp45_ = 0.0;
			gdouble _tmp46_ = 0.0;
			gdouble _tmp47_ = 0.0;
			_tmp45_ = t;
			_vala_r = _tmp45_;
			_tmp46_ = p;
			_vala_g = _tmp46_;
			_tmp47_ = v;
			_vala_b = _tmp47_;
			break;
		}
		case 5:
		{
			gdouble _tmp48_ = 0.0;
			gdouble _tmp49_ = 0.0;
			gdouble _tmp50_ = 0.0;
			_tmp48_ = v;
			_vala_r = _tmp48_;
			_tmp49_ = p;
			_vala_g = _tmp49_;
			_tmp50_ = q;
			_vala_b = _tmp50_;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	if (r) {
		*r = _vala_r;
	}
	if (g) {
		*g = _vala_g;
	}
	if (b) {
		*b = _vala_b;
	}
}


/**
 * Convert color to string formatted like "%d;;%d;;%d;;%d"
 * with numeric entries ranged in 0..255
 *
 * @return the string representation of this color
 */
gchar* plank_color_to_prefs_string (PlankColor *self) {
	gchar* result = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gchar* _tmp4_ = NULL;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	_tmp3_ = (*self).alpha;
	_tmp4_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (_tmp0_ * G_MAXUINT8), (gint) (_tmp1_ * G_MAXUINT8), (gint) (_tmp2_ * G_MAXUINT8), (gint) (_tmp3_ * G_MAXUINT8));
	result = _tmp4_;
	return result;
}


/**
 * Create new color converted from string formatted like
 * "%d;;%d;;%d;;%d" with numeric entries ranged in 0..255
 *
 * @return new {@link Color} based on the given string
 */
void plank_color_from_prefs_string (const gchar* s, PlankColor* result) {
	gchar** parts = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint parts_length1 = 0;
	gint _parts_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const gchar* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gdouble _tmp9_ = 0.0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gdouble _tmp13_ = 0.0;
	gchar** _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	const gchar* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gdouble _tmp17_ = 0.0;
	gchar** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const gchar* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gdouble _tmp21_ = 0.0;
	PlankColor _tmp22_ = {0};
	g_return_if_fail (s != NULL);
	_tmp0_ = s;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ";;", 0);
	parts = _tmp2_;
	parts_length1 = _vala_array_length (_tmp1_);
	_parts_size_ = parts_length1;
	_tmp3_ = parts;
	_tmp3__length1 = parts_length1;
	if (_tmp3__length1 != 4) {
		const gchar* _tmp4_ = NULL;
		PlankColor _tmp5_ = {0};
		_tmp4_ = s;
		g_critical ("Color.vala:517: Malformed color string '%s'", _tmp4_);
		*result = _tmp5_;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp6_ = parts;
	_tmp6__length1 = parts_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = atoi (_tmp7_);
	_tmp9_ = CLAMP ((gdouble) _tmp8_, 0.0, (gdouble) G_MAXUINT8);
	_tmp10_ = parts;
	_tmp10__length1 = parts_length1;
	_tmp11_ = _tmp10_[1];
	_tmp12_ = atoi (_tmp11_);
	_tmp13_ = CLAMP ((gdouble) _tmp12_, 0.0, (gdouble) G_MAXUINT8);
	_tmp14_ = parts;
	_tmp14__length1 = parts_length1;
	_tmp15_ = _tmp14_[2];
	_tmp16_ = atoi (_tmp15_);
	_tmp17_ = CLAMP ((gdouble) _tmp16_, 0.0, (gdouble) G_MAXUINT8);
	_tmp18_ = parts;
	_tmp18__length1 = parts_length1;
	_tmp19_ = _tmp18_[3];
	_tmp20_ = atoi (_tmp19_);
	_tmp21_ = CLAMP ((gdouble) _tmp20_, 0.0, (gdouble) G_MAXUINT8);
	_tmp22_.red = _tmp9_ / G_MAXUINT8;
	_tmp22_.green = _tmp13_ / G_MAXUINT8;
	_tmp22_.blue = _tmp17_ / G_MAXUINT8;
	_tmp22_.alpha = _tmp21_ / G_MAXUINT8;
	*result = _tmp22_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	return;
}


PlankColor* plank_color_dup (const PlankColor* self) {
	PlankColor* dup;
	dup = g_new0 (PlankColor, 1);
	memcpy (dup, self, sizeof (PlankColor));
	return dup;
}


void plank_color_free (PlankColor* self) {
	g_free (self);
}


GType plank_color_get_type (void) {
	static volatile gsize plank_color_type_id__volatile = 0;
	if (g_once_init_enter (&plank_color_type_id__volatile)) {
		GType plank_color_type_id;
		plank_color_type_id = g_boxed_type_register_static ("PlankColor", (GBoxedCopyFunc) plank_color_dup, (GBoxedFreeFunc) plank_color_free);
		g_once_init_leave (&plank_color_type_id__volatile, plank_color_type_id);
	}
	return plank_color_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



