/* Utils.c generated by valac 0.32.1, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



GSettings* plank_create_settings (const gchar* schema_id, const gchar* path);
GSettings* plank_try_create_settings (const gchar* schema_id, const gchar* path);
gchar** plank_string_split_combine (const gchar* s, const gchar* delimiter, int* result_length1);
void plank_combine_strings (gchar*** _result_, int* _result__length1, const gchar* delimiter, gint n, gint i);
gboolean plank_file_is_dockitem (GFile* file);
gdouble plank_nround (gdouble d, guint n);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Creates a new {@link GLib.Settings} object with a given schema and path.
 *
 * It is fatal if no schema to the given schema_id is found!
 *
 * If path is NULL then the path from the schema is used. It is an error if
 * path is NULL and the schema has no path of its own or if path is non-NULL
 * and not equal to the path that the schema does have.
 *
 * @param schema_id a schema ID
 * @param path the path to use
 * @return a new GLib.Settings object
 */
GSettings* plank_create_settings (const gchar* schema_id, const gchar* path) {
	GSettings* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GSettingsSchema* _tmp6_ = NULL;
	const gchar* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	g_return_val_if_fail (schema_id != NULL, NULL);
	_tmp0_ = g_get_current_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "/data", NULL);
	_tmp3_ = _tmp2_;
	g_setenv ("GSETTINGS_SCHEMA_DIR", _tmp3_, FALSE);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp4_ = g_settings_schema_source_get_default ();
	_tmp5_ = schema_id;
	_tmp6_ = g_settings_schema_source_lookup (_tmp4_, _tmp5_, TRUE);
	schema = _tmp6_;
	if (schema == NULL) {
		const gchar* _tmp7_ = NULL;
		_tmp7_ = schema_id;
		g_error ("Utils.vala:42: GSettingsSchema '%s' not found", _tmp7_);
	}
	_tmp8_ = path;
	_tmp9_ = g_settings_new_full (schema, NULL, _tmp8_);
	result = _tmp9_;
	_g_settings_schema_unref0 (schema);
	return result;
}


/**
 * Tries to create a new {@link GLib.Settings} object with a given schema and path.
 *
 * If path is NULL then the path from the schema is used. It is an error if
 * path is NULL and the schema has no path of its own or if path is non-NULL
 * and not equal to the path that the schema does have.
 *
 * @param schema_id a schema ID
 * @param path the path to use
 * @return a new GLib.Settings object or NULL
 */
GSettings* plank_try_create_settings (const gchar* schema_id, const gchar* path) {
	GSettings* result = NULL;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GSettingsSchema* _tmp2_ = NULL;
	GSettingsSchema* _tmp3_ = NULL;
	GSettingsSchema* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GSettings* _tmp7_ = NULL;
	g_return_val_if_fail (schema_id != NULL, NULL);
	_tmp0_ = g_settings_schema_source_get_default ();
	_tmp1_ = schema_id;
	_tmp2_ = g_settings_schema_source_lookup (_tmp0_, _tmp1_, TRUE);
	schema = _tmp2_;
	_tmp3_ = schema;
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_ = NULL;
		_tmp4_ = schema_id;
		g_warning ("Utils.vala:62: GSettingsSchema '%s' not found", _tmp4_);
		result = NULL;
		_g_settings_schema_unref0 (schema);
		return result;
	}
	_tmp5_ = schema;
	_tmp6_ = path;
	_tmp7_ = g_settings_new_full (_tmp5_, NULL, _tmp6_);
	result = _tmp7_;
	_g_settings_schema_unref0 (schema);
	return result;
}


/**
 * Generates an array containing all combinations of a splitted strings parts
 * while preserving the given order of them.
 *
 * @param s a string
 * @param delimiter a delimiter string
 * @return an array of concated strings
 */
gchar** plank_string_split_combine (const gchar* s, const gchar* delimiter, int* result_length1) {
	gchar** result = NULL;
	gchar** parts = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint parts_length1 = 0;
	gint _parts_size_ = 0;
	gint count = 0;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gchar** _result_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gchar** _tmp7_ = NULL;
	gint _result__length1 = 0;
	gint __result__size_ = 0;
	gint pos = 0;
	const gchar* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gchar** _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
	g_return_val_if_fail (s != NULL, NULL);
	g_return_val_if_fail (delimiter != NULL, NULL);
	_tmp0_ = s;
	_tmp1_ = delimiter;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp0_, _tmp1_, 0);
	parts = _tmp3_;
	parts_length1 = _vala_array_length (_tmp2_);
	_parts_size_ = parts_length1;
	_tmp4_ = parts;
	_tmp4__length1 = parts_length1;
	count = _tmp4__length1;
	_tmp5_ = count;
	_tmp6_ = count;
	_tmp7_ = g_new0 (gchar*, ((_tmp5_ * (_tmp6_ + 1)) / 2) + 1);
	_result_ = _tmp7_;
	_result__length1 = (_tmp5_ * (_tmp6_ + 1)) / 2;
	__result__size_ = _result__length1;
	pos = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gchar** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gint _tmp13_ = 0;
				gchar** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				gint _tmp15_ = 0;
				const gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
				if (!_tmp8_) {
					gint _tmp9_ = 0;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = i;
				_tmp11_ = count;
				if (!(_tmp10_ < _tmp11_)) {
					break;
				}
				_tmp12_ = _result_;
				_tmp12__length1 = _result__length1;
				_tmp13_ = pos;
				_tmp14_ = parts;
				_tmp14__length1 = parts_length1;
				_tmp15_ = i;
				_tmp16_ = _tmp14_[_tmp15_];
				_tmp17_ = g_strdup (_tmp16_);
				_g_free0 (_tmp12_[_tmp13_]);
				_tmp12_[_tmp13_] = _tmp17_;
				_tmp18_ = _tmp12_[_tmp13_];
				_tmp19_ = pos;
				_tmp20_ = count;
				_tmp21_ = i;
				pos = _tmp19_ + (_tmp20_ - _tmp21_);
			}
		}
	}
	_tmp22_ = delimiter;
	_tmp23_ = count;
	plank_combine_strings (&_result_, &_result__length1, _tmp22_, 0, _tmp23_);
	_tmp24_ = _result_;
	_tmp24__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp24__length1;
	}
	result = _tmp24_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


void plank_combine_strings (gchar*** _result_, int* _result__length1, const gchar* delimiter, gint n, gint i) {
	gint _tmp0_ = 0;
	gint pos = 0;
	gint _tmp1_ = 0;
	const gchar* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	g_return_if_fail (delimiter != NULL);
	_tmp0_ = i;
	if (_tmp0_ <= 1) {
		return;
	}
	_tmp1_ = n;
	pos = _tmp1_;
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				gchar** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gchar** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				const gchar* _tmp15_ = NULL;
				const gchar* _tmp16_ = NULL;
				gchar** _tmp17_ = NULL;
				gint _tmp17__length1 = 0;
				gint _tmp18_ = 0;
				const gchar* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				if (!_tmp2_) {
					gint _tmp3_ = 0;
					_tmp3_ = j;
					j = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = j;
				_tmp5_ = i;
				if (!(_tmp4_ < (_tmp5_ - 1))) {
					break;
				}
				_tmp6_ = pos;
				_tmp7_ = i;
				_tmp8_ = j;
				pos = _tmp6_ + (_tmp7_ - _tmp8_);
				_tmp9_ = *_result_;
				_tmp9__length1 = *_result__length1;
				_tmp10_ = n;
				_tmp11_ = j;
				_tmp12_ = *_result_;
				_tmp12__length1 = *_result__length1;
				_tmp13_ = n;
				_tmp14_ = j;
				_tmp15_ = _tmp12_[_tmp13_ + _tmp14_];
				_tmp16_ = delimiter;
				_tmp17_ = *_result_;
				_tmp17__length1 = *_result__length1;
				_tmp18_ = pos;
				_tmp19_ = _tmp17_[_tmp18_];
				_tmp20_ = g_strdup_printf ("%s%s%s", _tmp15_, _tmp16_, _tmp19_);
				_g_free0 (_tmp9_[(_tmp10_ + _tmp11_) + 1]);
				_tmp9_[(_tmp10_ + _tmp11_) + 1] = _tmp20_;
				_tmp21_ = _tmp9_[(_tmp10_ + _tmp11_) + 1];
			}
		}
	}
	_tmp22_ = delimiter;
	_tmp23_ = n;
	_tmp24_ = i;
	_tmp25_ = i;
	plank_combine_strings (_result_, _result__length1, _tmp22_, _tmp23_ + _tmp24_, _tmp25_ - 1);
}


/**
 * Whether the given file looks like a valid .dockitem file
 */
inline gboolean plank_file_is_dockitem (GFile* file) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, FALSE);
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = file;
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, 0, NULL, &_inner_error_);
		info = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp3_ = g_file_info_get_is_hidden (info);
		if (!_tmp3_) {
			const gchar* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
			_tmp4_ = g_file_info_get_name (info);
			_tmp5_ = g_str_has_suffix (_tmp4_, ".dockitem");
			_tmp2_ = _tmp5_;
		} else {
			_tmp2_ = FALSE;
		}
		result = _tmp2_;
		_g_object_unref0 (info);
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Utils.vala:119: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	return result;
}


inline gdouble plank_nround (gdouble d, guint n) {
	gdouble result = 0.0;
	gdouble _result_ = 0.0;
	guint _tmp0_ = 0U;
	_tmp0_ = n;
	if (_tmp0_ > 0U) {
		gdouble fac = 0.0;
		guint _tmp1_ = 0U;
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		_tmp1_ = n;
		_tmp2_ = pow (10.0, (gdouble) _tmp1_);
		fac = _tmp2_;
		_tmp3_ = d;
		_tmp4_ = fac;
		_tmp5_ = round (_tmp3_ * _tmp4_);
		_tmp6_ = fac;
		_result_ = _tmp5_ / _tmp6_;
	} else {
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
		_tmp7_ = d;
		_tmp8_ = round (_tmp7_);
		_result_ = _tmp8_;
	}
	result = _result_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



