/* WindowControl.c generated by valac 0.32.1, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>


#define PLANK_TYPE_STRUTS (plank_struts_get_type ())

#define PLANK_TYPE_WINDOW_CONTROL (plank_window_control_get_type ())
#define PLANK_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControl))
#define PLANK_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControlClass))
#define PLANK_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_WINDOW_CONTROL))
#define PLANK_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_WINDOW_CONTROL))
#define PLANK_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControlClass))

typedef struct _PlankWindowControl PlankWindowControl;
typedef struct _PlankWindowControlClass PlankWindowControlClass;
typedef struct _PlankWindowControlPrivate PlankWindowControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;

typedef enum  {
	PLANK_STRUTS_LEFT,
	PLANK_STRUTS_RIGHT,
	PLANK_STRUTS_TOP,
	PLANK_STRUTS_BOTTOM,
	PLANK_STRUTS_LEFT_START,
	PLANK_STRUTS_LEFT_END,
	PLANK_STRUTS_RIGHT_START,
	PLANK_STRUTS_RIGHT_END,
	PLANK_STRUTS_TOP_START,
	PLANK_STRUTS_TOP_END,
	PLANK_STRUTS_BOTTOM_START,
	PLANK_STRUTS_BOTTOM_END,
	PLANK_STRUTS_N_VALUES
} PlankStruts;

struct _PlankWindowControl {
	GObject parent_instance;
	PlankWindowControlPrivate * priv;
};

struct _PlankWindowControlClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	guint32 event_time;
};


static gpointer plank_window_control_parent_class = NULL;
static guint plank_window_control_delayed_focus_timer_id;
static guint plank_window_control_delayed_focus_timer_id = 0U;
static WnckWindow* plank_window_control_delayed_focus_window;
static WnckWindow* plank_window_control_delayed_focus_window = NULL;

GType plank_struts_get_type (void) G_GNUC_CONST;
GType plank_window_control_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_WINDOW_CONTROL_DUMMY_PROPERTY
};
#define PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY 10000U
#define PLANK_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY 200U
static PlankWindowControl* plank_window_control_new (void);
static PlankWindowControl* plank_window_control_construct (GType object_type);
void plank_window_control_initialize (void);
static void plank_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self);
static void plank_window_control_handle_window_closed (WnckWindow* window);
static void _plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
GdkPixbuf* plank_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_window_control_get_window_icon (BamfWindow* window);
gboolean plank_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace);
void plank_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect);
void plank_window_control_close_all (BamfApplication* app, guint32 event_time);
void plank_window_control_focus_window (BamfWindow* window, guint32 event_time);
static void plank_window_control_center_and_focus_window (WnckWindow* w, guint32 event_time);
static void plank_window_control_focus_window_by_xid (guint32 xid, guint32 event_time);
static gint plank_window_control_find_active_xid_index (GArray* xids);
void plank_window_control_focus_previous (BamfApplication* app, guint32 event_time);
void plank_window_control_focus_next (BamfApplication* app, guint32 event_time);
void plank_window_control_minimize (BamfApplication* app);
GList* plank_window_control_get_ordered_window_stack (BamfApplication* app);
void plank_window_control_restore (BamfApplication* app, guint32 event_time);
void plank_window_control_maximize (BamfApplication* app);
void plank_window_control_unmaximize (BamfApplication* app);
void plank_window_control_smart_focus (BamfApplication* app, guint32 event_time);
static void plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows, guint32 event_time);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean plank_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second);
static gboolean __lambda4_ (Block1Data* _data1_);
static gboolean ___lambda4__gsource_func (gpointer self);
void plank_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result);
static void plank_window_control_finalize (GObject* obj);


GType plank_struts_get_type (void) {
	static volatile gsize plank_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_STRUTS_LEFT, "PLANK_STRUTS_LEFT", "left"}, {PLANK_STRUTS_RIGHT, "PLANK_STRUTS_RIGHT", "right"}, {PLANK_STRUTS_TOP, "PLANK_STRUTS_TOP", "top"}, {PLANK_STRUTS_BOTTOM, "PLANK_STRUTS_BOTTOM", "bottom"}, {PLANK_STRUTS_LEFT_START, "PLANK_STRUTS_LEFT_START", "left-start"}, {PLANK_STRUTS_LEFT_END, "PLANK_STRUTS_LEFT_END", "left-end"}, {PLANK_STRUTS_RIGHT_START, "PLANK_STRUTS_RIGHT_START", "right-start"}, {PLANK_STRUTS_RIGHT_END, "PLANK_STRUTS_RIGHT_END", "right-end"}, {PLANK_STRUTS_TOP_START, "PLANK_STRUTS_TOP_START", "top-start"}, {PLANK_STRUTS_TOP_END, "PLANK_STRUTS_TOP_END", "top-end"}, {PLANK_STRUTS_BOTTOM_START, "PLANK_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_STRUTS_BOTTOM_END, "PLANK_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_STRUTS_N_VALUES, "PLANK_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_struts_type_id;
		plank_struts_type_id = g_enum_register_static ("PlankStruts", values);
		g_once_init_leave (&plank_struts_type_id__volatile, plank_struts_type_id);
	}
	return plank_struts_type_id__volatile;
}


static PlankWindowControl* plank_window_control_construct (GType object_type) {
	PlankWindowControl * self = NULL;
	self = (PlankWindowControl*) g_object_new (object_type, NULL);
	return self;
}


static PlankWindowControl* plank_window_control_new (void) {
	return plank_window_control_construct (PLANK_TYPE_WINDOW_CONTROL);
}


static void _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self) {
	plank_window_control_window_manager_changed (_sender);
}


static void _plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	plank_window_control_handle_window_closed (window);
}


void plank_window_control_initialize (void) {
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	WnckScreen* _tmp3_ = NULL;
	WnckScreen* _tmp4_ = NULL;
	WnckScreen* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	_tmp0_ = wnck_screen_get_default ();
	screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	gdk_error_trap_push ();
	_tmp1_ = screen;
	wnck_screen_force_update (_tmp1_);
	_tmp2_ = gdk_error_trap_pop ();
	if (_tmp2_ != 0) {
		g_critical ("WindowControl.vala:63: Wnck.Screen.force_update() caused a XError");
	}
	_tmp3_ = screen;
	g_signal_connect_after (_tmp3_, "window-manager-changed", (GCallback) _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
	_tmp4_ = screen;
	g_signal_connect_after (_tmp4_, "window-closed", (GCallback) _plank_window_control_handle_window_closed_wnck_screen_window_closed, NULL);
	_tmp5_ = screen;
	_tmp6_ = wnck_screen_get_window_manager_name (_tmp5_);
	g_message ("WindowControl.vala:68: Window-manager: %s", _tmp6_);
}


static void plank_window_control_window_manager_changed (WnckScreen* screen) {
	WnckScreen* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	WnckScreen* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (screen != NULL);
	gdk_error_trap_push ();
	_tmp0_ = screen;
	wnck_screen_force_update (_tmp0_);
	_tmp1_ = gdk_error_trap_pop ();
	if (_tmp1_ != 0) {
		g_critical ("WindowControl.vala:77: Wnck.Screen.force_update() caused a XError");
	}
	_tmp2_ = screen;
	_tmp3_ = wnck_screen_get_window_manager_name (_tmp2_);
	g_warning ("WindowControl.vala:79: Window-manager changed: %s", _tmp3_);
}


static void plank_window_control_handle_window_closed (WnckWindow* window) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_ = 0U;
	g_return_if_fail (window != NULL);
	_tmp1_ = plank_window_control_delayed_focus_timer_id;
	if (_tmp1_ > 0U) {
		WnckWindow* _tmp2_ = NULL;
		WnckWindow* _tmp3_ = NULL;
		_tmp2_ = plank_window_control_delayed_focus_window;
		_tmp3_ = window;
		_tmp0_ = _tmp2_ == _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		guint _tmp4_ = 0U;
		_tmp4_ = plank_window_control_delayed_focus_timer_id;
		g_source_remove (_tmp4_);
		plank_window_control_delayed_focus_timer_id = 0U;
		_g_object_unref0 (plank_window_control_delayed_focus_window);
		plank_window_control_delayed_focus_window = NULL;
	}
}


GdkPixbuf* plank_window_control_get_app_icon (BamfApplication* app) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	gint _tmp21_ = 0;
	GdkPixbuf* _tmp25_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	pbuf = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	gdk_error_trap_push ();
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				WnckWindow* _tmp17_ = NULL;
				GdkPixbuf* _tmp18_ = NULL;
				WnckWindow* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp7_ = xids;
				if (_tmp7_ != NULL) {
					gint _tmp8_ = 0;
					GArray* _tmp9_ = NULL;
					guint _tmp10_ = 0U;
					_tmp8_ = i;
					_tmp9_ = xids;
					_tmp10_ = _tmp9_->len;
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					GdkPixbuf* _tmp11_ = NULL;
					_tmp11_ = pbuf;
					_tmp5_ = _tmp11_ == NULL;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp16_ = window;
				if (_tmp16_ == NULL) {
					continue;
				}
				_tmp17_ = window;
				_tmp18_ = wnck_window_get_icon (_tmp17_);
				pbuf = _tmp18_;
				_tmp19_ = window;
				_tmp20_ = wnck_window_get_icon_is_fallback (_tmp19_);
				if (_tmp20_) {
					pbuf = NULL;
				}
				break;
			}
		}
	}
	_tmp21_ = gdk_error_trap_pop ();
	if (_tmp21_ != 0) {
		BamfApplication* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		_tmp22_ = app;
		_tmp23_ = bamf_view_get_name ((BamfView*) _tmp22_);
		_tmp24_ = _tmp23_;
		g_critical ("WindowControl.vala:115: get_app_icon() for '%s' caused a XError", _tmp24_);
		_g_free0 (_tmp24_);
	}
	_tmp25_ = pbuf;
	result = _tmp25_;
	_g_array_unref0 (xids);
	return result;
}


GdkPixbuf* plank_window_control_get_window_icon (BamfWindow* window) {
	GdkPixbuf* result = NULL;
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	GdkPixbuf* pbuf = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	WnckWindow* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_ = 0;
	GdkPixbuf* _tmp13_ = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	pbuf = NULL;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		result = NULL;
		return result;
	}
	gdk_error_trap_push ();
	_tmp5_ = w;
	_tmp6_ = wnck_window_get_icon (_tmp5_);
	pbuf = _tmp6_;
	_tmp7_ = w;
	_tmp8_ = wnck_window_get_icon_is_fallback (_tmp7_);
	if (_tmp8_) {
		pbuf = NULL;
	}
	_tmp9_ = gdk_error_trap_pop ();
	if (_tmp9_ != 0) {
		BamfWindow* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		_tmp10_ = window;
		_tmp11_ = bamf_view_get_name ((BamfView*) _tmp10_);
		_tmp12_ = _tmp11_;
		g_critical ("WindowControl.vala:137: get_window_icon() for '%s' caused a XError", _tmp12_);
		_g_free0 (_tmp12_);
	}
	_tmp13_ = pbuf;
	result = _tmp13_;
	return result;
}


gboolean plank_window_control_has_maximized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_maximized (_tmp16_);
					_tmp14_ = _tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_window_control_has_minimized_window (BamfApplication* app) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_minimized (_tmp16_);
					_tmp14_ = _tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean plank_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace) {
	gboolean result = FALSE;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	gboolean is_virtual = FALSE;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (app != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = workspace;
	_tmp4_ = wnck_workspace_is_virtual (_tmp3_);
	is_virtual = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp7_ = FALSE;
				GArray* _tmp8_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
				if (!_tmp5_) {
					gint _tmp6_ = 0;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = xids;
				if (_tmp8_ != NULL) {
					gint _tmp9_ = 0;
					GArray* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
					_tmp9_ = i;
					_tmp10_ = xids;
					_tmp11_ = _tmp10_->len;
					_tmp7_ = ((guint) _tmp9_) < _tmp11_;
				} else {
					_tmp7_ = FALSE;
				}
				if (!_tmp7_) {
					break;
				}
				_tmp12_ = xids;
				_tmp13_ = i;
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
				window = _tmp15_;
				_tmp16_ = window;
				if (_tmp16_ == NULL) {
					continue;
				}
				_tmp17_ = is_virtual;
				if (!_tmp17_) {
					WnckWindow* _tmp18_ = NULL;
					WnckWorkspace* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					_tmp18_ = window;
					_tmp19_ = workspace;
					_tmp20_ = wnck_window_is_on_workspace (_tmp18_, _tmp19_);
					if (_tmp20_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				} else {
					WnckWindow* _tmp21_ = NULL;
					WnckWorkspace* _tmp22_ = NULL;
					gboolean _tmp23_ = FALSE;
					_tmp21_ = window;
					_tmp22_ = workspace;
					_tmp23_ = wnck_window_is_in_viewport (_tmp21_, _tmp22_);
					if (_tmp23_) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


void plank_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	g_return_if_fail (rect != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				WnckWindow* _tmp14_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp14_ = window;
				if (_tmp14_ != NULL) {
					WnckWindow* _tmp15_ = NULL;
					GdkRectangle _tmp16_ = {0};
					gint _tmp17_ = 0;
					GdkRectangle _tmp18_ = {0};
					gint _tmp19_ = 0;
					GdkRectangle _tmp20_ = {0};
					gint _tmp21_ = 0;
					GdkRectangle _tmp22_ = {0};
					gint _tmp23_ = 0;
					_tmp15_ = window;
					_tmp16_ = *rect;
					_tmp17_ = _tmp16_.x;
					_tmp18_ = *rect;
					_tmp19_ = _tmp18_.y;
					_tmp20_ = *rect;
					_tmp21_ = _tmp20_.width;
					_tmp22_ = *rect;
					_tmp23_ = _tmp22_.height;
					wnck_window_set_icon_geometry (_tmp15_, _tmp17_, _tmp19_, _tmp21_, _tmp23_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_window_control_close_all (BamfApplication* app, guint32 event_time) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_ = NULL;
				WnckWindow* window = NULL;
				GArray* _tmp10_ = NULL;
				gint _tmp11_ = 0;
				guint32 _tmp12_ = 0U;
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WnckWindow* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GArray* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = xids;
				_tmp11_ = i;
				_tmp12_ = g_array_index (_tmp10_, guint32, (guint) _tmp11_);
				_tmp13_ = wnck_window_get ((gulong) _tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				if (_tmp15_ != NULL) {
					WnckWindow* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
					_tmp16_ = window;
					_tmp17_ = wnck_window_is_skip_tasklist (_tmp16_);
					_tmp14_ = !_tmp17_;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					WnckWindow* _tmp18_ = NULL;
					guint32 _tmp19_ = 0U;
					_tmp18_ = window;
					_tmp19_ = event_time;
					wnck_window_close (_tmp18_, _tmp19_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void plank_window_control_focus_window (BamfWindow* window, guint32 event_time) {
	WnckWindow* w = NULL;
	BamfWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	WnckWindow* _tmp5_ = NULL;
	guint32 _tmp6_ = 0U;
	g_return_if_fail (window != NULL);
	wnck_screen_get_default ();
	_tmp0_ = window;
	_tmp1_ = bamf_window_get_xid (_tmp0_);
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
	w = _tmp2_;
	_tmp3_ = w;
	g_warn_if_fail (_tmp3_ != NULL);
	_tmp4_ = w;
	if (_tmp4_ == NULL) {
		return;
	}
	_tmp5_ = w;
	_tmp6_ = event_time;
	plank_window_control_center_and_focus_window (_tmp5_, _tmp6_);
}


static void plank_window_control_focus_window_by_xid (guint32 xid, guint32 event_time) {
	WnckWindow* w = NULL;
	guint32 _tmp0_ = 0U;
	WnckWindow* _tmp1_ = NULL;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
	guint32 _tmp5_ = 0U;
	wnck_screen_get_default ();
	_tmp0_ = xid;
	_tmp1_ = wnck_window_get ((gulong) _tmp0_);
	w = _tmp1_;
	_tmp2_ = w;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = w;
	if (_tmp3_ == NULL) {
		return;
	}
	_tmp4_ = w;
	_tmp5_ = event_time;
	plank_window_control_center_and_focus_window (_tmp4_, _tmp5_);
}


static gint plank_window_control_find_active_xid_index (GArray* xids) {
	gint result = 0;
	gint i = 0;
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			GArray* _tmp3_ = NULL;
			WnckWindow* window = NULL;
			GArray* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			guint32 _tmp9_ = 0U;
			WnckWindow* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			WnckWindow* _tmp12_ = NULL;
			if (!_tmp0_) {
				gint _tmp1_ = 0;
				_tmp1_ = i;
				i = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp3_ = xids;
			if (_tmp3_ != NULL) {
				gint _tmp4_ = 0;
				GArray* _tmp5_ = NULL;
				guint _tmp6_ = 0U;
				_tmp4_ = i;
				_tmp5_ = xids;
				_tmp6_ = _tmp5_->len;
				_tmp2_ = ((guint) _tmp4_) < _tmp6_;
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
			_tmp7_ = xids;
			_tmp8_ = i;
			_tmp9_ = g_array_index (_tmp7_, guint32, (guint) _tmp8_);
			_tmp10_ = wnck_window_get ((gulong) _tmp9_);
			window = _tmp10_;
			_tmp12_ = window;
			if (_tmp12_ != NULL) {
				WnckWindow* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				_tmp13_ = window;
				_tmp14_ = wnck_window_is_active (_tmp13_);
				_tmp11_ = _tmp14_;
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				break;
			}
		}
	}
	result = i;
	return result;
}


void plank_window_control_focus_previous (BamfApplication* app, guint32 event_time) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	GArray* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	guint32 _tmp16_ = 0U;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ - 1;
	} else {
		_tmp6_ = 0;
	}
	i = _tmp6_;
	_tmp11_ = i;
	if (_tmp11_ < 0) {
		GArray* _tmp12_ = NULL;
		guint _tmp13_ = 0U;
		_tmp12_ = xids;
		_tmp13_ = _tmp12_->len;
		i = ((gint) _tmp13_) - 1;
	}
	_tmp14_ = xids;
	_tmp15_ = i;
	_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
	_tmp17_ = event_time;
	plank_window_control_focus_window_by_xid (_tmp16_, _tmp17_);
	_g_array_unref0 (xids);
}


void plank_window_control_focus_next (BamfApplication* app, guint32 event_time) {
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	gint i = 0;
	GArray* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp11_ = 0;
	GArray* _tmp12_ = NULL;
	guint _tmp13_ = 0U;
	GArray* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	guint32 _tmp16_ = 0U;
	guint32 _tmp17_ = 0U;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp4_ = xids;
	_tmp5_ = plank_window_control_find_active_xid_index (_tmp4_);
	i = _tmp5_;
	_tmp7_ = i;
	_tmp8_ = xids;
	_tmp9_ = _tmp8_->len;
	if (((guint) _tmp7_) < _tmp9_) {
		gint _tmp10_ = 0;
		_tmp10_ = i;
		_tmp6_ = _tmp10_ + 1;
	} else {
		_tmp6_ = 0;
	}
	i = _tmp6_;
	_tmp11_ = i;
	_tmp12_ = xids;
	_tmp13_ = _tmp12_->len;
	if (((guint) _tmp11_) == _tmp13_) {
		i = 0;
	}
	_tmp14_ = xids;
	_tmp15_ = i;
	_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
	_tmp17_ = event_time;
	plank_window_control_focus_window_by_xid (_tmp16_, _tmp17_);
	_g_array_unref0 (xids);
}


void plank_window_control_minimize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp2_ = NULL;
				WnckScreen* _tmp3_ = NULL;
				WnckWorkspace* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				WnckWindow* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_get_screen (_tmp2_);
				_tmp4_ = wnck_screen_get_active_workspace (_tmp3_);
				active_workspace = _tmp4_;
				_tmp7_ = window;
				_tmp8_ = wnck_window_is_minimized (_tmp7_);
				if (!_tmp8_) {
					WnckWorkspace* _tmp9_ = NULL;
					_tmp9_ = active_workspace;
					_tmp6_ = _tmp9_ != NULL;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					WnckWindow* _tmp10_ = NULL;
					WnckWorkspace* _tmp11_ = NULL;
					gboolean _tmp12_ = FALSE;
					_tmp10_ = window;
					_tmp11_ = active_workspace;
					_tmp12_ = wnck_window_is_in_viewport (_tmp10_, _tmp11_);
					_tmp5_ = _tmp12_;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					WnckWindow* _tmp13_ = NULL;
					_tmp13_ = window;
					wnck_window_minimize (_tmp13_);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_window_control_restore (BamfApplication* app, guint32 event_time) {
	GList* stack = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_window_control_get_ordered_window_stack (_tmp0_);
	stack = _tmp1_;
	stack = g_list_reverse (stack);
	_tmp2_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp3_ = NULL;
				WnckScreen* _tmp4_ = NULL;
				WnckWorkspace* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				WnckWindow* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
				_tmp3_ = window;
				_tmp4_ = wnck_window_get_screen (_tmp3_);
				_tmp5_ = wnck_screen_get_active_workspace (_tmp4_);
				active_workspace = _tmp5_;
				_tmp8_ = window;
				_tmp9_ = wnck_window_is_minimized (_tmp8_);
				if (_tmp9_) {
					WnckWorkspace* _tmp10_ = NULL;
					_tmp10_ = active_workspace;
					_tmp7_ = _tmp10_ != NULL;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					WnckWindow* _tmp11_ = NULL;
					WnckWorkspace* _tmp12_ = NULL;
					gboolean _tmp13_ = FALSE;
					_tmp11_ = window;
					_tmp12_ = active_workspace;
					_tmp13_ = wnck_window_is_in_viewport (_tmp11_, _tmp12_);
					_tmp6_ = _tmp13_;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					WnckWindow* _tmp14_ = NULL;
					guint32 _tmp15_ = 0U;
					_tmp14_ = window;
					_tmp15_ = event_time;
					wnck_window_unminimize (_tmp14_, _tmp15_);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_g_list_free0 (stack);
}


void plank_window_control_maximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (!_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_maximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


void plank_window_control_unmaximize (BamfApplication* app) {
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_window_control_get_ordered_window_stack (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_maximized (_tmp2_);
				if (_tmp3_) {
					WnckWindow* _tmp4_ = NULL;
					_tmp4_ = window;
					wnck_window_unmaximize (_tmp4_);
				}
			}
		}
		_g_list_free0 (window_collection);
	}
}


GList* plank_window_control_get_ordered_window_stack (BamfApplication* app) {
	GList* result = NULL;
	GList* windows = NULL;
	GArray* xids = NULL;
	BamfApplication* _tmp0_ = NULL;
	GArray* _tmp1_ = NULL;
	GArray* _tmp2_ = NULL;
	GArray* _tmp3_ = NULL;
	GList* stack = NULL;
	WnckScreen* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	windows = NULL;
	wnck_screen_get_default ();
	_tmp0_ = app;
	_tmp1_ = bamf_application_get_xids (_tmp0_);
	xids = _tmp1_;
	_tmp2_ = xids;
	g_warn_if_fail (_tmp2_ != NULL);
	_tmp3_ = xids;
	if (_tmp3_ == NULL) {
		result = windows;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp4_ = wnck_screen_get_default ();
	_tmp5_ = wnck_screen_get_windows_stacked (_tmp4_);
	stack = _tmp5_;
	_tmp6_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp6_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gint _tmp9_ = 0;
							GArray* _tmp10_ = NULL;
							guint _tmp11_ = 0U;
							GArray* _tmp12_ = NULL;
							gint _tmp13_ = 0;
							guint32 _tmp14_ = 0U;
							WnckWindow* _tmp15_ = NULL;
							gulong _tmp16_ = 0UL;
							if (!_tmp7_) {
								gint _tmp8_ = 0;
								_tmp8_ = j;
								j = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							_tmp9_ = j;
							_tmp10_ = xids;
							_tmp11_ = _tmp10_->len;
							if (!(((guint) _tmp9_) < _tmp11_)) {
								break;
							}
							_tmp12_ = xids;
							_tmp13_ = j;
							_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
							_tmp15_ = window;
							_tmp16_ = wnck_window_get_xid (_tmp15_);
							if (((gulong) _tmp14_) == _tmp16_) {
								WnckWindow* _tmp17_ = NULL;
								_tmp17_ = window;
								windows = g_list_append (windows, _tmp17_);
							}
						}
					}
				}
			}
		}
	}
	result = windows;
	_g_array_unref0 (xids);
	return result;
}


void plank_window_control_smart_focus (BamfApplication* app, guint32 event_time) {
	GList* windows = NULL;
	BamfApplication* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	GList* _tmp2_ = NULL;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	GList* _tmp29_ = NULL;
	GList* _tmp50_ = NULL;
	GList* _tmp75_ = NULL;
	GList* _tmp90_ = NULL;
	gconstpointer _tmp91_ = NULL;
	GList* _tmp92_ = NULL;
	guint32 _tmp93_ = 0U;
	g_return_if_fail (app != NULL);
	_tmp0_ = app;
	_tmp1_ = plank_window_control_get_ordered_window_stack (_tmp0_);
	windows = _tmp1_;
	not_in_viewport = TRUE;
	urgent = FALSE;
	_tmp2_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp2_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp3_ = NULL;
				WnckScreen* _tmp4_ = NULL;
				WnckWorkspace* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				WnckWindow* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
				WnckWindow* _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				_tmp3_ = window;
				_tmp4_ = wnck_window_get_screen (_tmp3_);
				_tmp5_ = wnck_screen_get_active_workspace (_tmp4_);
				active_workspace = _tmp5_;
				_tmp8_ = window;
				_tmp9_ = wnck_window_is_skip_tasklist (_tmp8_);
				if (!_tmp9_) {
					WnckWorkspace* _tmp10_ = NULL;
					_tmp10_ = active_workspace;
					_tmp7_ = _tmp10_ != NULL;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					WnckWindow* _tmp11_ = NULL;
					WnckWorkspace* _tmp12_ = NULL;
					gboolean _tmp13_ = FALSE;
					_tmp11_ = window;
					_tmp12_ = active_workspace;
					_tmp13_ = wnck_window_is_in_viewport (_tmp11_, _tmp12_);
					_tmp6_ = _tmp13_;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					not_in_viewport = FALSE;
				}
				_tmp14_ = window;
				_tmp15_ = wnck_window_needs_attention (_tmp14_);
				if (_tmp15_) {
					urgent = TRUE;
				}
			}
		}
	}
	_tmp17_ = not_in_viewport;
	if (_tmp17_) {
		_tmp16_ = TRUE;
	} else {
		gboolean _tmp18_ = FALSE;
		_tmp18_ = urgent;
		_tmp16_ = _tmp18_;
	}
	if (_tmp16_) {
		GList* _tmp19_ = NULL;
		_tmp19_ = windows;
		{
			GList* window_collection = NULL;
			GList* window_it = NULL;
			window_collection = _tmp19_;
			for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
				WnckWindow* window = NULL;
				window = (WnckWindow*) window_it->data;
				{
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
					WnckWindow* _tmp24_ = NULL;
					gboolean _tmp25_ = FALSE;
					_tmp21_ = urgent;
					if (_tmp21_) {
						WnckWindow* _tmp22_ = NULL;
						gboolean _tmp23_ = FALSE;
						_tmp22_ = window;
						_tmp23_ = wnck_window_needs_attention (_tmp22_);
						_tmp20_ = !_tmp23_;
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						continue;
					}
					_tmp24_ = window;
					_tmp25_ = wnck_window_is_skip_tasklist (_tmp24_);
					if (!_tmp25_) {
						WnckWindow* _tmp26_ = NULL;
						GList* _tmp27_ = NULL;
						guint32 _tmp28_ = 0U;
						_tmp26_ = window;
						_tmp27_ = windows;
						_tmp28_ = event_time;
						plank_window_control_intelligent_focus_off_viewport_window (_tmp26_, _tmp27_, _tmp28_);
						_g_list_free0 (windows);
						return;
					}
				}
			}
		}
	}
	_tmp29_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp29_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp30_ = NULL;
				WnckScreen* _tmp31_ = NULL;
				WnckWorkspace* _tmp32_ = NULL;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				WnckWindow* _tmp35_ = NULL;
				gboolean _tmp36_ = FALSE;
				_tmp30_ = window;
				_tmp31_ = wnck_window_get_screen (_tmp30_);
				_tmp32_ = wnck_screen_get_active_workspace (_tmp31_);
				active_workspace = _tmp32_;
				_tmp35_ = window;
				_tmp36_ = wnck_window_is_minimized (_tmp35_);
				if (_tmp36_) {
					WnckWorkspace* _tmp37_ = NULL;
					_tmp37_ = active_workspace;
					_tmp34_ = _tmp37_ != NULL;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					WnckWindow* _tmp38_ = NULL;
					WnckWorkspace* _tmp39_ = NULL;
					gboolean _tmp40_ = FALSE;
					_tmp38_ = window;
					_tmp39_ = active_workspace;
					_tmp40_ = wnck_window_is_in_viewport (_tmp38_, _tmp39_);
					_tmp33_ = _tmp40_;
				} else {
					_tmp33_ = FALSE;
				}
				if (_tmp33_) {
					GList* _tmp41_ = NULL;
					_tmp41_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp41_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp42_ = FALSE;
								WnckWindow* _tmp43_ = NULL;
								gboolean _tmp44_ = FALSE;
								_tmp43_ = w;
								_tmp44_ = wnck_window_is_minimized (_tmp43_);
								if (_tmp44_) {
									WnckWindow* _tmp45_ = NULL;
									WnckWorkspace* _tmp46_ = NULL;
									gboolean _tmp47_ = FALSE;
									_tmp45_ = w;
									_tmp46_ = active_workspace;
									_tmp47_ = wnck_window_is_in_viewport (_tmp45_, _tmp46_);
									_tmp42_ = _tmp47_;
								} else {
									_tmp42_ = FALSE;
								}
								if (_tmp42_) {
									WnckWindow* _tmp48_ = NULL;
									guint32 _tmp49_ = 0U;
									_tmp48_ = w;
									_tmp49_ = event_time;
									wnck_window_unminimize (_tmp48_, _tmp49_);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp50_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp50_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp51_ = NULL;
				WnckScreen* _tmp52_ = NULL;
				WnckWorkspace* _tmp53_ = NULL;
				gboolean _tmp54_ = FALSE;
				gboolean _tmp55_ = FALSE;
				gboolean _tmp56_ = FALSE;
				WnckWindow* _tmp57_ = NULL;
				gboolean _tmp58_ = FALSE;
				_tmp51_ = window;
				_tmp52_ = wnck_window_get_screen (_tmp51_);
				_tmp53_ = wnck_screen_get_active_workspace (_tmp52_);
				active_workspace = _tmp53_;
				_tmp57_ = window;
				_tmp58_ = wnck_window_is_active (_tmp57_);
				if (_tmp58_) {
					WnckWorkspace* _tmp59_ = NULL;
					_tmp59_ = active_workspace;
					_tmp56_ = _tmp59_ != NULL;
				} else {
					_tmp56_ = FALSE;
				}
				if (_tmp56_) {
					WnckWindow* _tmp60_ = NULL;
					WnckWorkspace* _tmp61_ = NULL;
					gboolean _tmp62_ = FALSE;
					_tmp60_ = window;
					_tmp61_ = active_workspace;
					_tmp62_ = wnck_window_is_in_viewport (_tmp60_, _tmp61_);
					_tmp55_ = _tmp62_;
				} else {
					_tmp55_ = FALSE;
				}
				if (_tmp55_) {
					_tmp54_ = TRUE;
				} else {
					WnckWindow* _tmp63_ = NULL;
					WnckWindow* _tmp64_ = NULL;
					WnckScreen* _tmp65_ = NULL;
					WnckWindow* _tmp66_ = NULL;
					_tmp63_ = window;
					_tmp64_ = window;
					_tmp65_ = wnck_window_get_screen (_tmp64_);
					_tmp66_ = wnck_screen_get_active_window (_tmp65_);
					_tmp54_ = _tmp63_ == _tmp66_;
				}
				if (_tmp54_) {
					GList* _tmp67_ = NULL;
					_tmp67_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp67_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp68_ = FALSE;
								WnckWindow* _tmp69_ = NULL;
								gboolean _tmp70_ = FALSE;
								_tmp69_ = w;
								_tmp70_ = wnck_window_is_minimized (_tmp69_);
								if (!_tmp70_) {
									WnckWindow* _tmp71_ = NULL;
									WnckWorkspace* _tmp72_ = NULL;
									gboolean _tmp73_ = FALSE;
									_tmp71_ = w;
									_tmp72_ = active_workspace;
									_tmp73_ = wnck_window_is_in_viewport (_tmp71_, _tmp72_);
									_tmp68_ = _tmp73_;
								} else {
									_tmp68_ = FALSE;
								}
								if (_tmp68_) {
									WnckWindow* _tmp74_ = NULL;
									_tmp74_ = w;
									wnck_window_minimize (_tmp74_);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp75_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp75_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp76_ = NULL;
				WnckScreen* _tmp77_ = NULL;
				WnckWorkspace* _tmp78_ = NULL;
				gboolean _tmp79_ = FALSE;
				WnckWorkspace* _tmp80_ = NULL;
				_tmp76_ = window;
				_tmp77_ = wnck_window_get_screen (_tmp76_);
				_tmp78_ = wnck_screen_get_active_workspace (_tmp77_);
				active_workspace = _tmp78_;
				_tmp80_ = active_workspace;
				if (_tmp80_ != NULL) {
					WnckWindow* _tmp81_ = NULL;
					WnckWorkspace* _tmp82_ = NULL;
					gboolean _tmp83_ = FALSE;
					_tmp81_ = window;
					_tmp82_ = active_workspace;
					_tmp83_ = wnck_window_is_in_viewport (_tmp81_, _tmp82_);
					_tmp79_ = _tmp83_;
				} else {
					_tmp79_ = FALSE;
				}
				if (_tmp79_) {
					GList* _tmp84_ = NULL;
					_tmp84_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp84_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								WnckWindow* _tmp85_ = NULL;
								WnckWorkspace* _tmp86_ = NULL;
								gboolean _tmp87_ = FALSE;
								_tmp85_ = w;
								_tmp86_ = active_workspace;
								_tmp87_ = wnck_window_is_in_viewport (_tmp85_, _tmp86_);
								if (_tmp87_) {
									WnckWindow* _tmp88_ = NULL;
									guint32 _tmp89_ = 0U;
									_tmp88_ = w;
									_tmp89_ = event_time;
									plank_window_control_center_and_focus_window (_tmp88_, _tmp89_);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					_g_list_free0 (windows);
					return;
				}
			}
		}
	}
	_tmp90_ = windows;
	_tmp91_ = g_list_nth_data (_tmp90_, (guint) 0);
	_tmp92_ = windows;
	_tmp93_ = event_time;
	plank_window_control_intelligent_focus_off_viewport_window ((WnckWindow*) _tmp91_, _tmp92_, _tmp93_);
	_g_list_free0 (windows);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean __lambda4_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	WnckWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	plank_window_control_delayed_focus_timer_id = 0U;
	_tmp0_ = plank_window_control_delayed_focus_window;
	_tmp1_ = _data1_->event_time;
	wnck_window_activate (_tmp0_, _tmp1_);
	_g_object_unref0 (plank_window_control_delayed_focus_window);
	plank_window_control_delayed_focus_window = NULL;
	result = FALSE;
	return result;
}


static gboolean ___lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda4_ (self);
	return result;
}


static void plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GList* additional_windows, guint32 event_time) {
	Block1Data* _data1_;
	guint32 _tmp0_ = 0U;
	GList* _tmp1_ = NULL;
	WnckWindow* _tmp10_ = NULL;
	guint32 _tmp11_ = 0U;
	GList* _tmp12_ = NULL;
	guint _tmp13_ = 0U;
	guint _tmp14_ = 0U;
	WnckWindow* _tmp16_ = NULL;
	WnckWindow* _tmp17_ = NULL;
	guint _tmp18_ = 0U;
	g_return_if_fail (targetWindow != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = event_time;
	_data1_->event_time = _tmp0_;
	additional_windows = g_list_reverse (additional_windows);
	_tmp1_ = additional_windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp2_ = FALSE;
				WnckWindow* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				_tmp3_ = window;
				_tmp4_ = wnck_window_is_minimized (_tmp3_);
				if (!_tmp4_) {
					WnckWindow* _tmp5_ = NULL;
					WnckWindow* _tmp6_ = NULL;
					gboolean _tmp7_ = FALSE;
					_tmp5_ = targetWindow;
					_tmp6_ = window;
					_tmp7_ = plank_window_control_windows_share_viewport (_tmp5_, _tmp6_);
					_tmp2_ = _tmp7_;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					WnckWindow* _tmp8_ = NULL;
					guint32 _tmp9_ = 0U;
					_tmp8_ = window;
					_tmp9_ = _data1_->event_time;
					plank_window_control_center_and_focus_window (_tmp8_, _tmp9_);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	_tmp10_ = targetWindow;
	_tmp11_ = _data1_->event_time;
	plank_window_control_center_and_focus_window (_tmp10_, _tmp11_);
	_tmp12_ = additional_windows;
	_tmp13_ = g_list_length (_tmp12_);
	if (_tmp13_ <= ((guint) 1)) {
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	_tmp14_ = plank_window_control_delayed_focus_timer_id;
	if (_tmp14_ > 0U) {
		guint _tmp15_ = 0U;
		_tmp15_ = plank_window_control_delayed_focus_timer_id;
		g_source_remove (_tmp15_);
	}
	_tmp16_ = targetWindow;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	_g_object_unref0 (plank_window_control_delayed_focus_window);
	plank_window_control_delayed_focus_window = _tmp17_;
	_tmp18_ = gdk_threads_add_timeout (PLANK_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda4__gsource_func, _data1_);
	plank_window_control_delayed_focus_timer_id = _tmp18_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static gboolean plank_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_ = NULL;
	WnckWorkspace* wksp = NULL;
	WnckWindow* _tmp3_ = NULL;
	WnckWorkspace* _tmp4_ = NULL;
	WnckWorkspace* _tmp5_ = NULL;
	WnckWorkspace* _tmp8_ = NULL;
	GdkRectangle firstGeo = {0};
	GdkRectangle _tmp9_ = {0};
	GdkRectangle secondGeo = {0};
	GdkRectangle _tmp10_ = {0};
	WnckWindow* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	WnckWindow* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	WnckWorkspace* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	WnckWorkspace* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	WnckWorkspace* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	WnckWorkspace* _tmp31_ = NULL;
	gint _tmp32_ = 0;
	gint viewportWidth = 0;
	WnckWindow* _tmp33_ = NULL;
	WnckScreen* _tmp34_ = NULL;
	gint _tmp35_ = 0;
	gint viewportHeight = 0;
	WnckWindow* _tmp36_ = NULL;
	WnckScreen* _tmp37_ = NULL;
	gint _tmp38_ = 0;
	gint firstViewportX = 0;
	GdkRectangle _tmp39_ = {0};
	gint _tmp40_ = 0;
	GdkRectangle _tmp41_ = {0};
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	gint firstViewportY = 0;
	GdkRectangle _tmp45_ = {0};
	gint _tmp46_ = 0;
	GdkRectangle _tmp47_ = {0};
	gint _tmp48_ = 0;
	gint _tmp49_ = 0;
	gint _tmp50_ = 0;
	GdkRectangle viewpRect = {0};
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	gint _tmp54_ = 0;
	GdkRectangle _tmp55_ = {0};
	GdkRectangle _tmp56_ = {0};
	gboolean _tmp57_ = FALSE;
	_tmp1_ = first;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		WnckWindow* _tmp2_ = NULL;
		_tmp2_ = second;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = first;
	_tmp4_ = wnck_window_get_workspace (_tmp3_);
	wksp = _tmp4_;
	_tmp5_ = wksp;
	if (_tmp5_ == NULL) {
		WnckWindow* _tmp6_ = NULL;
		WnckWorkspace* _tmp7_ = NULL;
		_tmp6_ = second;
		_tmp7_ = wnck_window_get_workspace (_tmp6_);
		wksp = _tmp7_;
	}
	_tmp8_ = wksp;
	if (_tmp8_ == NULL) {
		result = FALSE;
		return result;
	}
	firstGeo = _tmp9_;
	secondGeo = _tmp10_;
	_tmp11_ = first;
	wnck_window_get_geometry (_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
	firstGeo.x = _tmp12_;
	firstGeo.y = _tmp13_;
	firstGeo.width = _tmp14_;
	firstGeo.height = _tmp15_;
	_tmp16_ = second;
	wnck_window_get_geometry (_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_, &_tmp20_);
	secondGeo.x = _tmp17_;
	secondGeo.y = _tmp18_;
	secondGeo.width = _tmp19_;
	secondGeo.height = _tmp20_;
	_tmp21_ = firstGeo.x;
	_tmp22_ = wksp;
	_tmp23_ = wnck_workspace_get_viewport_x (_tmp22_);
	firstGeo.x = _tmp21_ + _tmp23_;
	_tmp24_ = firstGeo.y;
	_tmp25_ = wksp;
	_tmp26_ = wnck_workspace_get_viewport_y (_tmp25_);
	firstGeo.y = _tmp24_ + _tmp26_;
	_tmp27_ = secondGeo.x;
	_tmp28_ = wksp;
	_tmp29_ = wnck_workspace_get_viewport_x (_tmp28_);
	secondGeo.x = _tmp27_ + _tmp29_;
	_tmp30_ = secondGeo.y;
	_tmp31_ = wksp;
	_tmp32_ = wnck_workspace_get_viewport_y (_tmp31_);
	secondGeo.y = _tmp30_ + _tmp32_;
	_tmp33_ = first;
	_tmp34_ = wnck_window_get_screen (_tmp33_);
	_tmp35_ = wnck_screen_get_width (_tmp34_);
	viewportWidth = _tmp35_;
	_tmp36_ = first;
	_tmp37_ = wnck_window_get_screen (_tmp36_);
	_tmp38_ = wnck_screen_get_height (_tmp37_);
	viewportHeight = _tmp38_;
	_tmp39_ = firstGeo;
	_tmp40_ = _tmp39_.x;
	_tmp41_ = firstGeo;
	_tmp42_ = _tmp41_.width;
	_tmp43_ = viewportWidth;
	_tmp44_ = viewportWidth;
	firstViewportX = ((_tmp40_ + (_tmp42_ / 2)) / _tmp43_) * _tmp44_;
	_tmp45_ = firstGeo;
	_tmp46_ = _tmp45_.y;
	_tmp47_ = firstGeo;
	_tmp48_ = _tmp47_.height;
	_tmp49_ = viewportHeight;
	_tmp50_ = viewportHeight;
	firstViewportY = ((_tmp46_ + (_tmp48_ / 2)) / _tmp49_) * _tmp50_;
	_tmp51_ = firstViewportX;
	_tmp52_ = firstViewportY;
	_tmp53_ = viewportWidth;
	_tmp54_ = viewportHeight;
	_tmp55_.x = _tmp51_;
	_tmp55_.y = _tmp52_;
	_tmp55_.width = _tmp53_;
	_tmp55_.height = _tmp54_;
	viewpRect = _tmp55_;
	_tmp56_ = secondGeo;
	_tmp57_ = gdk_rectangle_intersect (&viewpRect, &_tmp56_, NULL);
	result = _tmp57_;
	return result;
}


static void plank_window_control_center_and_focus_window (WnckWindow* w, guint32 event_time) {
	WnckWorkspace* workspace = NULL;
	WnckWindow* _tmp0_ = NULL;
	WnckWorkspace* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	WnckWorkspace* _tmp3_ = NULL;
	WnckWindow* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	WnckWindow* _tmp14_ = NULL;
	guint32 _tmp15_ = 0U;
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	_tmp1_ = wnck_window_get_workspace (_tmp0_);
	workspace = _tmp1_;
	_tmp3_ = workspace;
	if (_tmp3_ != NULL) {
		WnckWorkspace* _tmp4_ = NULL;
		WnckWindow* _tmp5_ = NULL;
		WnckScreen* _tmp6_ = NULL;
		WnckWorkspace* _tmp7_ = NULL;
		_tmp4_ = workspace;
		_tmp5_ = w;
		_tmp6_ = wnck_window_get_screen (_tmp5_);
		_tmp7_ = wnck_screen_get_active_workspace (_tmp6_);
		_tmp2_ = _tmp4_ != _tmp7_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		WnckWorkspace* _tmp8_ = NULL;
		guint32 _tmp9_ = 0U;
		_tmp8_ = workspace;
		_tmp9_ = event_time;
		wnck_workspace_activate (_tmp8_, _tmp9_);
	}
	_tmp10_ = w;
	_tmp11_ = wnck_window_is_minimized (_tmp10_);
	if (_tmp11_) {
		WnckWindow* _tmp12_ = NULL;
		guint32 _tmp13_ = 0U;
		_tmp12_ = w;
		_tmp13_ = event_time;
		wnck_window_unminimize (_tmp12_, _tmp13_);
	}
	_tmp14_ = w;
	_tmp15_ = event_time;
	wnck_window_activate_transient (_tmp14_, _tmp15_);
}


void plank_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result) {
	GdkRectangle geo = {0};
	GdkRectangle _tmp0_ = {0};
	WnckWindow* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (w != NULL);
	geo = _tmp0_;
	_tmp1_ = w;
	wnck_window_get_geometry (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	geo.x = _tmp2_;
	geo.y = _tmp3_;
	geo.width = _tmp4_;
	geo.height = _tmp5_;
	*result = geo;
	return;
}


static void plank_window_control_class_init (PlankWindowControlClass * klass) {
	plank_window_control_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_window_control_finalize;
}


static void plank_window_control_instance_init (PlankWindowControl * self) {
}


static void plank_window_control_finalize (GObject* obj) {
	PlankWindowControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_WINDOW_CONTROL, PlankWindowControl);
	G_OBJECT_CLASS (plank_window_control_parent_class)->finalize (obj);
}


GType plank_window_control_get_type (void) {
	static volatile gsize plank_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankWindowControl), 0, (GInstanceInitFunc) plank_window_control_instance_init, NULL };
		GType plank_window_control_type_id;
		plank_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_window_control_type_id__volatile, plank_window_control_type_id);
	}
	return plank_window_control_type_id__volatile;
}



